
// Based upon EbumProcess.prg By Dr. Claudio Soto (April 2014)

*****************************************************************************************************
* Attention: 
*   - to detect processes 32 and 64 bits you should compiling with HMG-64 bits (Build64.bat)
*   - Process_Name is case sensitive and requires file extention ( mostly .exe )
*****************************************************************************************************

#include <hmg.ch>

PROCEDURE Main()

   DEFINE WINDOW frmGPITest ;
      AT 0,0 ;
      WIDTH 400 ;
      HEIGHT 250 ;
      BACKCOLOR TEAL;
      TITLE 'Get Process ID test' ;
      ON INIT GetProcessID_Test() ;
      MAIN 
      
      ON KEY ESCAPE ACTION ThisWindow.Release
      
      @ 100, 100 BUTTON btnApply CAPTION "Aplly" ACTION GetProcessID_Test()
   END WINDOW
   
   frmGPITest.Center
   frmGPITest.Activate
   
RETURN  // GetProcessID.Test.Main()  
      
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
      
PROCEDURE GetProcessID_Test()

   LOCAL cProcessNm,;
         nProcessID
   
   WHILE .T.
      cProcessNm := INPUTBOX( 'Enter process name' , 'Get Process ID from name' , cProcessNm )
      IF EMPTY( cProcessNm  )
         EXIT 
      ENDIF
      nProcessID := GetProcessID( cProcessNm )
      IF HB_ISNIL( nProcessID )
         MsgStop( cProcessNm + " not running !" ) 
      ELSE
         MsgInfo( "Process ID of " + cProcessNm + " is : " + NTOC( nProcessID )  )          
      ENDIF      
   ENDDO

RETURN // GetProcessID.Test()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

FUNCTION GetProcessID( cProcessName )

   LOCAL aProcessesIDs := EnumProcessesID(),;
         n1ProcID,;
         c1ProcName,;
         nRetVal 
         

   FOR EACH n1ProcID IN aProcessesIDs 
      c1ProcName := GetProcessName( n1ProcID )
      IF cProcessName == c1ProcName
         nRetVal := n1ProcID
         EXIT 
      ENDIF   
   NEXT
   
RETURN nRetVal // GetProcessID()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
